## libsfml 3.0.0+dfsg

=== debian/changelog ===
libsfml (3.0.0+dfsg-1) experimental; urgency=medium

  * New upstream version.

  * d/patches: Drop patches applied upstream.

 -- James Cowgill <jcowgill@debian.org>  Thu, 26 Dec 2024 12:40:27 +0000

libsfml (3.0.0~rc2+dfsg-1) experimental; urgency=medium

  * New upstream release candidate.

  * d/copyright: Updates for -rc2.
  * d/patches:
    - Refresh patches.
    - Add patches to fix big-endian issues.
  * d/libsfml-doc.links: Add missing tuffy.ttf symlink.
  * d/rules: Only build docs in arch-indep builds.
  * d/tests:
    - Rename existing tests to "smoke-".
    - Add a test runs the upstream testsuite.

 -- James Cowgill <jcowgill@debian.org>  Sun, 08 Dec 2024 12:33:56 +0000

libsfml (3.0.0~rc1+dfsg-1) experimental; urgency=medium

  * New upstream release candidate.

  * d/control:
    - Change library package suffix to 3.0
    - Build depend on catch2, miniaudio and xi.
  * d/copyright:
    - Update list of excluded libraries and exclude the bundled Gradle
      wrapper JAR.
    - Updates for 3.0.
  * d/libsfml-doc.README.Debian: Remove.
  * d/libsfml-doc.docs: Install the upstream readme and migration guide.
  * d/libsfml-doc.links: Add more tuffy.ttf links.
  * d/patches:
    - Refresh and drop patches applied upstream
    - Add patch to use the system Catch2 instead of downloading it.
    - Add patch to skip sf::IpAddress tests that use the network.
  * d/rules:
    - Explicitly enable BUILD_SHARED_LIBS.
    - Disable hardware tests.
    - Remove android example.
  * d/watch:
    - Handle upstream rc version numbering.
    - Simplify options.
  * d/tests: Update to the new SFML API.

 -- James Cowgill <jcowgill@debian.org>  Sat, 30 Nov 2024 17:06:17 +0000

=== debian/tests/control ===
Tests: smoke-build
Depends: g++, libsfml-dev, pkg-config
Restrictions: superficial

Tests: smoke-cmake
Depends: cmake, g++, libsfml-dev, make
Restrictions: superficial

Tests: upstream-tests
Depends: cmake, g++, libcatch2-dev, libsfml-dev, make, xserver-xorg-core, xserver-xorg-video-dummy
Restrictions: allow-stderr breaks-testbed

## libsfml 3.0.1+dfsg

=== CMakeLists.txt ===
if(CMAKE_HOST_WIN32)
    # We require a CMake version greater than or equal to 3.24 on Windows in order to
    # support specifying target_include_directories with SYSTEM for Visual Studio Generators
    # see: https://cmake.org/cmake/help/latest/release/3.24.html#generators
    cmake_minimum_required(VERSION 3.24)
else()
    # For all other systems, 3.22 will suffice
    cmake_minimum_required(VERSION 3.22)
endif()

# define a macro that helps defining an option
macro(sfml_set_option var default type docstring)
    if(NOT DEFINED ${var})
        set(${var} ${default})
    endif()
    set(${var} ${${var}} CACHE ${type} ${docstring} FORCE)
endmacro()

# these options have to be set before CMake detects/configures the toolchain

# use new MSVC debug information format specification mechanism if available
# we use this mechanism to embed debug information into the object file to allow ccache to cache it
if(POLICY CMP0141)
    cmake_policy(SET CMP0141 NEW)
endif()

# determine whether to create a debug or release build
sfml_set_option(CMAKE_BUILD_TYPE Release STRING "Choose the type of build (Debug or Release)")
sfml_set_option(CMAKE_OSX_DEPLOYMENT_TARGET "13.0" STRING "The minimal iOS version that will be able to run the built binaries. Cannot be lower than 13.0")

# project name
project(SFML VERSION 3.0.1)

set(VERSION_IS_RELEASE ON)

# include the configuration file
include(cmake/Config.cmake)

# we use the paths from the cmake GNUInstallDirs module as defaults
# you can override these if you like
# https://cmake.org/cmake/help/latest/module/GNUInstallDirs.html
include(GNUInstallDirs)

# disable static libraries on Android
if(SFML_OS_ANDROID)
    set(BUILD_SHARED_LIBS ON)
endif()

# add options to select which modules to build
sfml_set_option(SFML_BUILD_WINDOW ON BOOL "ON to build SFML's Window module. This setting is ignored, if the graphics module is built.")
sfml_set_option(SFML_BUILD_GRAPHICS ON BOOL "ON to build SFML's Graphics module.")
sfml_set_option(SFML_BUILD_AUDIO ON BOOL "ON to build SFML's Audio module.")
sfml_set_option(SFML_BUILD_NETWORK ON BOOL "ON to build SFML's Network module.")

if(SFML_BUILD_WINDOW)
    # add an option for choosing the OpenGL implementation
    sfml_set_option(SFML_OPENGL_ES ${OPENGL_ES} BOOL "ON to use an OpenGL ES implementation, OFF to use a desktop OpenGL implementation")

    # add an option for choosing whether to use the DRM windowing backend
    if(SFML_OS_LINUX)
        sfml_set_option(SFML_USE_DRM OFF BOOL "ON to use DRM windowing backend")
    endif()
endif()

# macOS specific options
if(SFML_OS_MACOS OR SFML_OS_IOS)
    # add an option to build frameworks instead of dylibs (release only)
    sfml_set_option(SFML_BUILD_FRAMEWORKS OFF BOOL "ON to build SFML as frameworks libraries (release only), OFF to build according to BUILD_SHARED_LIBS")

    # add an option to automatically install Xcode templates
    sfml_set_option(SFML_INSTALL_XCODE_TEMPLATES OFF BOOL "ON to automatically install the Xcode templates, OFF to do nothing about it. The templates are compatible with Xcode 4 and 5.")
endif()

# Android options
if(SFML_OS_ANDROID)
    sfml_set_option(SFML_ANDROID_USE_SUSPEND_AWARE_CLOCK OFF BOOL "ON to use an sf::Clock implementation which takes system sleep time into account (keeps advancing during suspension), OFF to default to another available monotonic clock")
    if(SFML_ANDROID_USE_SUSPEND_AWARE_CLOCK)
        add_definitions(-DSFML_ANDROID_USE_SUSPEND_AWARE_CLOCK)
    endif()

    # avoid missing libraries when building SFML for Android with NDK r19c and later
    list(PREPEND CMAKE_FIND_ROOT_PATH "${PROJECT_SOURCE_DIR}")

    # install everything in $NDK/sources/ because this path is appended by the NDK (convenient)
    set(CMAKE_INSTALL_PREFIX ${CMAKE_ANDROID_NDK}/sources/third_party/sfml)

    # we install libs in a subdirectory named after the ABI
    set(CMAKE_INSTALL_LIBDIR "${CMAKE_INSTALL_LIBDIR}/${CMAKE_ANDROID_ARCH_ABI}")
endif()

# Install directories
# For miscellaneous files
if(SFML_OS_WINDOWS OR SFML_OS_IOS)
    set(DEFAULT_INSTALL_MISC_DIR .)
elseif(SFML_OS_LINUX OR SFML_OS_FREEBSD OR SFML_OS_OPENBSD OR SFML_OS_NETBSD)
    set(DEFAULT_INSTALL_MISC_DIR share/SFML)
elseif(SFML_OS_MACOS)
    set(DEFAULT_INSTALL_MISC_DIR /usr/local/share/SFML)
elseif(SFML_OS_ANDROID)
    set(DEFAULT_INSTALL_MISC_DIR ${CMAKE_ANDROID_NDK}/sources/third_party/sfml)
endif()

# force building sfml-window, if sfml-graphics module is built
if(SFML_BUILD_GRAPHICS AND NOT SFML_BUILD_WINDOW)
    message(WARNING "You're trying to build SFML's Graphics module without the Window module. Forcing building of the Window module as a dependency.")
    set(SFML_BUILD_WINDOW ON)
endif()

# use bundled dependencies by default on these systems and system dependencies by default on all others (maintains old behavior)
if(SFML_OS_WINDOWS OR SFML_OS_MACOS OR SFML_OS_IOS OR SFML_OS_ANDROID)
    set(SFML_USE_SYSTEM_DEPS_DEFAULT OFF)
else()
    set(SFML_USE_SYSTEM_DEPS_DEFAULT ON)
endif()

sfml_set_option(SFML_USE_SYSTEM_DEPS ${SFML_USE_SYSTEM_DEPS_DEFAULT} BOOL "ON to use system dependencies, OFF to use the bundled ones.")
if(SFML_USE_SYSTEM_DEPS AND SFML_INSTALL_XCODE_TEMPLATES)
    message(FATAL_ERROR "XCode templates installation cannot be used with the SFML_USE_SYSTEM_DEPS option (the bundled frameworks are required.)")
endif()

if(SFML_COMPILER_MSVC)
    # add an option to choose whether PDB debug symbols should be generated (defaults to true when possible)
    sfml_set_option(SFML_GENERATE_PDB ON BOOL "True to generate PDB debug symbols, OFF otherwise.")

    # if building using a compiler launcher, embed the MSVC debugging information to allow for caching
    if(CMAKE_CXX_COMPILER_LAUNCHER)
        set(CMAKE_MSVC_DEBUG_INFORMATION_FORMAT "$<$<CONFIG:Debug,RelWithDebInfo>:Embedded>")
    endif()
endif()

# define SFML_OPENGL_ES if needed
if(SFML_OPENGL_ES)
    add_definitions(-DSFML_OPENGL_ES)
    add_definitions(-DGL_GLEXT_PROTOTYPES)
endif()

# define an option for choosing between static and dynamic C runtime (Windows only)
if(SFML_OS_WINDOWS)
    sfml_set_option(SFML_USE_STATIC_STD_LIBS OFF BOOL "ON to statically link to the standard libraries, OFF to use them as DLLs")

    # the following combination of flags is not valid
    if(BUILD_SHARED_LIBS AND SFML_USE_STATIC_STD_LIBS)
        message(FATAL_ERROR "BUILD_SHARED_LIBS and SFML_USE_STATIC_STD_LIBS cannot be used together")
    endif()

    sfml_set_option(SFML_USE_MESA3D OFF BOOL "ON to use the Mesa 3D graphics library for rendering, OFF to use the system provided library for rendering")

    include(cmake/Mesa3D.cmake)
endif()

# setup macOS stuff
if(SFML_OS_MACOS)
    # SFML_BUILD_FRAMEWORKS needs two things:
    # first, it's available only for release
    #    (because cmake currently doesn't allow specifying a custom framework name so XXX-d is not possible)
    # secondly, it works only with BUILD_SHARED_LIBS enabled
    if(SFML_BUILD_FRAMEWORKS)
        # requirement #1
        if(NOT CMAKE_BUILD_TYPE STREQUAL "Release")
            message(FATAL_ERROR "CMAKE_BUILD_TYPE should be \"Release\" when SFML_BUILD_FRAMEWORKS is ON")
            return()
        endif()

        # requirement #2
        if(NOT BUILD_SHARED_LIBS)
            message(FATAL_ERROR "BUILD_SHARED_LIBS should be ON when SFML_BUILD_FRAMEWORKS is ON")
            return()
        endif()
    endif()

    # configure Xcode templates
    set(XCODE_TEMPLATES_ARCH "\$(NATIVE_ARCH_ACTUAL)")

    if(NOT SFML_COMPILER_CLANG)
        message(FATAL_ERROR "Clang is the only supported compiler on macOS")
    endif()
endif()

option(SFML_ENABLE_SANITIZERS "Enable sanitizers" OFF)
if(SFML_ENABLE_SANITIZERS)
    string(APPEND CMAKE_CXX_FLAGS " -fno-omit-frame-pointer -fno-sanitize-recover=all -fsanitize=undefined")
endif()

option(SFML_ENABLE_STDLIB_ASSERTIONS "Enable standard library assertions" OFF)
if(SFML_ENABLE_STDLIB_ASSERTIONS)
    # intentionally using `add_compile_definitions` here to propagate defines to subdirectories
    add_compile_definitions(_GLIBCXX_ASSERTIONS=1)                                   # see https://gcc.gnu.org/wiki/LibstdcxxDebugMode

    # Xcode has a property to control this - adding the define ourselves causes multiple definitions
    if(XCODE)
        set(CMAKE_XCODE_ATTRIBUTE_CLANG_CXX_STANDARD_LIBRARY_HARDENING "Yes (extensive)")
    else()
        add_compile_definitions(_LIBCPP_HARDENING_MODE=_LIBCPP_HARDENING_MODE_EXTENSIVE) # see https://libcxx.llvm.org/Hardening.html
    endif()
endif()

# set the output directory for SFML DLLs and executables
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/bin)

# enable project folders
set_property(GLOBAL PROPERTY USE_FOLDERS ON)
set_property(GLOBAL PROPERTY PREDEFINED_TARGETS_FOLDER "CMake")

# add the subdirectories
add_subdirectory(src/SFML)

# on Linux and BSD-like OS, install pkg-config files by default
set(SFML_INSTALL_PKGCONFIG_DEFAULT OFF)

if(SFML_OS_LINUX OR SFML_OS_FREEBSD OR SFML_OS_OPENBSD OR SFML_OS_NETBSD)
    set(SFML_INSTALL_PKGCONFIG_DEFAULT ON)
endif()

sfml_set_option(SFML_INSTALL_PKGCONFIG_FILES ${SFML_INSTALL_PKGCONFIG_DEFAULT} BOOL "ON to automatically install pkg-config files so other projects can find SFML")

if(SFML_INSTALL_PKGCONFIG_FILES)
    # account for CMAKE_INSTALL_LIBDIR potentially being an absolute path
    file(RELATIVE_PATH SFML_RELATIVE_INSTALL_LIBDIR ${CMAKE_INSTALL_PREFIX} ${CMAKE_INSTALL_FULL_LIBDIR})

    # set pkgconfig install directory
    # this could be e.g. macports on mac or msys2 on windows etc.
    set(SFML_PKGCONFIG_DIR "${SFML_RELATIVE_INSTALL_LIBDIR}/pkgconfig")

    if(SFML_OS_FREEBSD OR SFML_OS_OPENBSD OR SFML_OS_NETBSD)
        set(SFML_PKGCONFIG_DIR "libdata/pkgconfig")
    endif()

    sfml_set_option(SFML_PKGCONFIG_INSTALL_DIR "${SFML_PKGCONFIG_DIR}" PATH "Install directory for SFML's pkg-config .pc files")

    if(SFML_BUILD_AUDIO AND SFML_BUILD_NETWORK AND SFML_BUILD_GRAPHICS AND SFML_BUILD_WINDOW)
        configure_file(
            "tools/pkg-config/sfml-all.pc.in"
            "tools/pkg-config/sfml-all.pc"
            @ONLY)
        install(FILES "${CMAKE_CURRENT_BINARY_DIR}/tools/pkg-config/sfml-all.pc"
            DESTINATION "${SFML_PKGCONFIG_INSTALL_DIR}")
    endif()
endif()

# option to enable precompiled headers
sfml_set_option(SFML_ENABLE_PCH OFF BOOL "ON to enable precompiled headers for SFML builds -- only supported on Windows/Linux and for static library builds")

if(SFML_ENABLE_PCH AND BUILD_SHARED_LIBS)
    message(FATAL_ERROR "Precompiled headers are currently not supported for shared library builds")
endif()

if(SFML_ENABLE_PCH AND SFML_OS_MACOS)
    message(FATAL_ERROR "Precompiled headers are currently not supported in macOS builds")
endif()

# setup the install rules
if(NOT SFML_BUILD_FRAMEWORKS)
    install(DIRECTORY include/
            DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
            COMPONENT devel
            FILES_MATCHING PATTERN "*.hpp" PATTERN "*.inl")
    install(DIRECTORY cmake/Modules/
            DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/SFML
            COMPONENT devel)

    if(SFML_GENERATE_PDB)
        install(DIRECTORY ${PROJECT_BINARY_DIR}/lib/
                DESTINATION ${CMAKE_INSTALL_LIBDIR}
                COMPONENT devel
                FILES_MATCHING PATTERN "*.pdb")
    endif()
else()
    # find only "root" headers
    file(GLOB SFML_HEADERS RELATIVE ${PROJECT_SOURCE_DIR} "include/SFML/*")

    # Because we use generator expressions in the post build scripts we need to
    # suppress the generation of "EFFECTIVE_PLATFORM_NAME" as it will fail
    set_property(GLOBAL PROPERTY XCODE_EMIT_EFFECTIVE_PLATFORM_NAME OFF)

    # in fact we have to fool cmake to copy all the headers in subdirectories
    # to do that we have to add the "root" headers to the PUBLIC_HEADER
    # then we can run a post script to copy the remaining headers

    # we need a dummy file in order to compile the framework

=== debian/changelog ===
libsfml (3.0.1+dfsg-2) unstable; urgency=medium

  * Upload to unstable.

 -- James Cowgill <jcowgill@debian.org>  Wed, 03 Sep 2025 19:15:01 +0100

libsfml (3.0.1+dfsg-1) experimental; urgency=medium

  * New upstream version.

  * d/patches:
    - Refresh patches.
    - Use upstream version of 07_skip_IpAddress_tests.
    - Add patch to fix upstream pkg-config bug in 3.0.1.
    - Add patch to fix SFMLConfig.in with old CMake policy.
  * d/tests:
    - Set VERSION_IS_RELEASE in upstream-tests.
    - Disable CMake deprecation warnings.
    - Add smoke-cmake-min to test with old CMake policies.

 -- James Cowgill <jcowgill@debian.org>  Sat, 24 May 2025 17:50:57 +0100

=== debian/control ===
Source: libsfml
Section: libs
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 James Cowgill <jcowgill@debian.org>
Build-Depends: debhelper-compat (= 13),
 cmake,
 libcatch2-dev (>= 3.7),
 libflac-dev,
 libfreetype-dev,
 libgl-dev,
 libminiaudio-dev,
 libopenal-dev,
 libstb-dev,
 libudev-dev [linux-any],
 libusbhid-dev [kfreebsd-any],
 libvorbis-dev,
 libvulkan-dev,
 libx11-dev,
 libxcursor-dev,
 libxi-dev,
 libxrandr-dev,
 pkgconf,
Build-Depends-Indep: doxygen
Rules-Requires-Root: no
Standards-Version: 4.7.0
Homepage: https://www.sfml-dev.org/
Vcs-Git: https://salsa.debian.org/games-team/libsfml.git
Vcs-Browser: https://salsa.debian.org/games-team/libsfml

Package: libsfml-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
 libgl-dev,
 libsfml-audio3.0 (= ${binary:Version}),
 libsfml-graphics3.0 (= ${binary:Version}),
 libsfml-network3.0 (= ${binary:Version}),
 libsfml-system3.0 (= ${binary:Version}),
 libsfml-window3.0 (= ${binary:Version})
Suggests: libsfml-doc
Description: Simple and Fast Multimedia Library - Development Files
 SFML is a modern multimedia library offering a wide range of subsystems
 useful to produce a multimedia app. It offers OpenGL integration for
 Hardware accelerated Graphics, Windowing and Input support, Audio and
 Network facilities and supports GNU/Linux, MS Windows and Mac OS X.
 .
 This package includes header files for all SFML libraries.

Package: libsfml-audio3.0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
 libsfml-system3.0 (= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends}
Description: Simple and Fast Multimedia Library - Audio part
 SFML is a modern multimedia library offering a wide range of subsystems
 useful to produce a multimedia app. It offers OpenGL integration for
 Hardware accelerated Graphics, Windowing and Input support, Audio and
 Network facilities and supports GNU/Linux, MS Windows and Mac OS X.
 .
 The Audio library is used to play sound and music in games. It is able to
 load OGG/Vorbis files.

Package: libsfml-graphics3.0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
 libgl1,
 libsfml-system3.0 (= ${binary:Version}),
 libsfml-window3.0 (= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends}
Description: Simple and Fast Multimedia Library - Graphics part
 SFML is a modern multimedia library offering a wide range of subsystems
 useful to produce a multimedia app. It offers OpenGL integration for
 Hardware accelerated Graphics, Windowing and Input support, Audio and
 Network facilities and supports GNU/Linux, MS Windows and Mac OS X.
 .
 The Graphics library contains all the OpenGL and drawing code. It needs the
 Window library for Window creation.

Package: libsfml-network3.0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
 libsfml-system3.0 (= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends}
Description: Simple and Fast Multimedia Library - Network part
 SFML is a modern multimedia library offering a wide range of subsystems
 useful to produce a multimedia app. It offers OpenGL integration for
 Hardware accelerated Graphics, Windowing and Input support, Audio and
 Network facilities and supports GNU/Linux, MS Windows and Mac OS X.
 .
 The Network Library brings basic networking support as needed by games.

Package: libsfml-system3.0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Simple and Fast Multimedia Library - System part
 SFML is a modern multimedia library offering a wide range of subsystems
 useful to produce a multimedia app. It offers OpenGL integration for
 Hardware accelerated Graphics, Windowing and Input support, Audio and
 Network facilities and supports GNU/Linux, MS Windows and Mac OS X.
 .
 The system library brings useful system utilities like multithreading and
 UNICODE handling.

Package: libsfml-window3.0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
 libgl1,
 libsfml-system3.0 (= ${binary:Version}),
 libvulkan1,
 ${shlibs:Depends},
 ${misc:Depends}
Description: Simple and Fast Multimedia Library - Window part
 SFML is a modern multimedia library offering a wide range of subsystems
 useful to produce a multimedia app. It offers OpenGL integration for
 Hardware accelerated Graphics, Windowing and Input support, Audio and
 Network facilities and supports GNU/Linux, MS Windows and Mac OS X.
 .
 The Window library provides basic utilities for creating and managing Windows.

Package: libsfml-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: fonts-tuffy, ${misc:Depends}
Description: Simple and Fast Multimedia Library - Documentation
 SFML is a modern multimedia library offering a wide range of subsystems
 useful to produce a multimedia app. It offers OpenGL integration for
 Hardware accelerated Graphics, Windowing and Input support, Audio and
 Network facilities and supports GNU/Linux, MS Windows and Mac OS X.
 .
 This package includes the library reference and examples for SFML.

## libsfml 3.0.2%2Bdfsg

=== examples/ftp/CMakeLists.txt ===
# all source files
set(SRC Ftp.cpp)

# define the ftp target
sfml_add_example(ftp
                 SOURCES ${SRC}
                 DEPENDS SFML::Network)

=== examples/keyboard/CMakeLists.txt ===
# all source files
set(SRC Keyboard.cpp)
if(SFML_OS_IOS)
    set(RESOURCES
        resources/error_005.ogg
        resources/mouseclick1.ogg
        resources/mouserelease1.ogg
        resources/Tuffy.ttf)
    set_source_files_properties(${RESOURCES} PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
endif()

# define the keyboard target
sfml_add_example(keyboard GUI_APP
                 SOURCES ${SRC}
                 BUNDLE_RESOURCES ${RESOURCES}
                 DEPENDS SFML::Audio SFML::Graphics)

=== examples/sockets/CMakeLists.txt ===
# all source files
set(SRC Sockets.cpp
        TCP.cpp
        UDP.cpp)

# define the sockets target
sfml_add_example(sockets
                 SOURCES ${SRC}
                 DEPENDS SFML::Network)

=== examples/window/CMakeLists.txt ===
# all source files
set(SRC Window.cpp)

# define the window target
sfml_add_example(window GUI_APP
                 SOURCES ${SRC}
                 DEPENDS SFML::Window)

# external dependency headers
target_include_directories(window SYSTEM PRIVATE ${PROJECT_SOURCE_DIR}/examples/include)

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: libsfml
 Section: libs
-Priority: optional
 Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
 Uploaders:
  James Cowgill <jcowgill@debian.org>
@@ -14,7 +13,6 @@
  libopenal-dev,
  libstb-dev,
  libudev-dev [linux-any],
- libusbhid-dev [kfreebsd-any],
  libvorbis-dev,
  libvulkan-dev,
  libx11-dev,
@@ -23,8 +21,7 @@
  libxrandr-dev,
  pkgconf,
 Build-Depends-Indep: doxygen
-Rules-Requires-Root: no
-Standards-Version: 4.7.0
+Standards-Version: 4.7.3
 Homepage: https://www.sfml-dev.org/
 Vcs-Git: https://salsa.debian.org/games-team/libsfml.git
 Vcs-Browser: https://salsa.debian.org/games-team/libsfml

## libsfml 3.0.2+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -29,7 +29,7 @@
 sfml_set_option(CMAKE_OSX_DEPLOYMENT_TARGET "13.0" STRING "The minimal iOS version that will be able to run the built binaries. Cannot be lower than 13.0")
 
 # project name
-project(SFML VERSION 3.0.1)
+project(SFML VERSION 3.0.2)
 
 set(VERSION_IS_RELEASE ON)
 
@@ -201,9 +201,6 @@
 set_property(GLOBAL PROPERTY USE_FOLDERS ON)
 set_property(GLOBAL PROPERTY PREDEFINED_TARGETS_FOLDER "CMake")
 
-# add the subdirectories
-add_subdirectory(src/SFML)
-
 # on Linux and BSD-like OS, install pkg-config files by default
 set(SFML_INSTALL_PKGCONFIG_DEFAULT OFF)
 
@@ -247,6 +244,9 @@
 if(SFML_ENABLE_PCH AND SFML_OS_MACOS)
     message(FATAL_ERROR "Precompiled headers are currently not supported in macOS builds")
 endif()
+
+# add the subdirectories
+add_subdirectory(src/SFML)
 
 # setup the install rules
 if(NOT SFML_BUILD_FRAMEWORKS)

=== doc/CMakeLists.txt ===
# find doxygen
if(SFML_OS_MACOS)
    # Add some path to search doxygen in more directories.
    set(ADDITIONAL_PATHS
        /Developer/Applications/Doxygen.app/Contents/Resources
        /Developer/Applications/Doxygen.app/Contents/MacOS
        $ENV{HOME}/Applications/Doxygen.app/Contents/Resources
        $ENV{HOME}/Applications/Doxygen.app/Contents/MacOS
        $ENV{HOME}/Applications/Developer/Doxygen.app/Contents/Resources
        $ENV{HOME}/Applications/Developer/Doxygen.app/Contents/MacOS)

    list(APPEND CMAKE_PROGRAM_PATH ${ADDITIONAL_PATHS})
endif()

find_package(Doxygen REQUIRED)

# see if we can generate the CHM documentation
set(DOXYGEN_HHC_PROGRAM)
set(DOXYGEN_GENERATE_HTMLHELP NO)
if(SFML_OS_WINDOWS)
    # if HHC is found, we can generate the CHM (compressed HTML) output
    find_program(DOXYGEN_HHC_PROGRAM
                 NAMES hhc.exe
                 PATHS "C:/Program Files/HTML Help Workshop" "C:/Program Files (x86)/HTML Help Workshop"
                 DOC "HTML Help Compiler program")
    if(DOXYGEN_HHC_PROGRAM)
        if(DOXYGEN_VERSION VERSION_LESS "1.10.0")
            set(DOXYGEN_GENERATE_HTMLHELP YES)
        else()
            message("Due to conflicts with the HTML output settings in Doxygen ${DOXYGEN_VERSION}, the HTML Help generation will be disabled")
        endif()
    endif()
endif()

# configure the source Doxyfile by copying it and replacing all @variables@
configure_file(doxyfile.in doxyfile @ONLY)
configure_file(header.html.in header.html @ONLY)

# copy the files needed by the documentation
configure_file(doxygen.css html/doxygen.css COPYONLY)
configure_file(searchOverrides.css html/searchOverrides.css COPYONLY)

# target setup
add_custom_target(doc
                  COMMAND ${CMAKE_COMMAND} -E echo_append "Building API Documentation..."
                  COMMAND Doxygen::doxygen ${CMAKE_CURRENT_BINARY_DIR}/doxyfile
                  COMMAND ${CMAKE_COMMAND} -E echo "Done."
                  WORKING_DIRECTORY ${PROJECT_SOURCE_DIR})

# setup install rules
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/SFML.tag
        DESTINATION ${CMAKE_INSTALL_DOCDIR}
        COMPONENT doc)
install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html
        DESTINATION ${CMAKE_INSTALL_DOCDIR}
        COMPONENT doc)
if(DOXYGEN_GENERATE_HTMLHELP)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/sfml.chm
            DESTINATION ${CMAKE_INSTALL_DOCDIR}
            COMPONENT doc)
endif()

=== examples/CMakeLists.txt ===
# CLI based examples
if(NOT SFML_OS_IOS)
    if(SFML_BUILD_NETWORK)
        add_subdirectory(ftp)
        add_subdirectory(sockets)
    endif()
    if(SFML_BUILD_NETWORK AND SFML_BUILD_AUDIO)
        add_subdirectory(voip)
    endif()
    if(SFML_BUILD_AUDIO)
        add_subdirectory(sound)
        add_subdirectory(sound_capture)
    endif()
endif()

# GUI based examples
if(SFML_BUILD_WINDOW)
    add_subdirectory(window)
endif()

if(SFML_BUILD_GRAPHICS)
    add_subdirectory(event_handling)
    add_subdirectory(opengl)
    add_subdirectory(stencil)

    if(NOT SFML_OS_IOS)
        add_subdirectory(joystick)
        add_subdirectory(shader)
        add_subdirectory(island)
        add_subdirectory(vulkan)
    endif()

    if(SFML_OS_WINDOWS)
        add_subdirectory(win32)
        add_subdirectory(raw_input)
    elseif(SFML_OS_LINUX OR SFML_OS_FREEBSD)
        if(NOT SFML_USE_DRM)
            add_subdirectory(X11)
            add_subdirectory(raw_input)
        endif()
    elseif(SFML_OS_MACOS)
        add_subdirectory(cocoa)
    endif()
endif()
if(SFML_BUILD_GRAPHICS AND SFML_BUILD_AUDIO)
    add_subdirectory(tennis)
    add_subdirectory(keyboard)

    if(NOT SFML_OPENGL_ES)
        add_subdirectory(sound_effects)
    endif()
endif()

=== test/CMakeLists.txt ===
include(FetchContent)

add_subdirectory(install)
set_target_warnings(test-sfml-install)

set(CATCH_CONFIG_FAST_COMPILE ON CACHE BOOL "")
set(CATCH_CONFIG_NO_EXPERIMENTAL_STATIC_ANALYSIS_SUPPORT ON CACHE BOOL "")
FetchContent_Declare(Catch2
    GIT_REPOSITORY https://github.com/catchorg/Catch2.git
    GIT_TAG v3.8.1
    GIT_SHALLOW ON)
FetchContent_MakeAvailable(Catch2)
include(Catch)

# Build Catch2 in C++17 mode to enable C++17 features
target_compile_features(Catch2 PRIVATE cxx_std_17)

# Ensure that Catch2 sources and headers are not analyzed by any tools
set_target_properties(Catch2 PROPERTIES COMPILE_OPTIONS "" EXPORT_COMPILE_COMMANDS OFF)
set_target_properties(Catch2WithMain PROPERTIES EXPORT_COMPILE_COMMANDS OFF)
set_target_properties(Catch2 Catch2WithMain PROPERTIES FOLDER "Dependencies")
get_target_property(CATCH2_INCLUDE_DIRS Catch2 INTERFACE_INCLUDE_DIRECTORIES)
target_include_directories(Catch2 SYSTEM INTERFACE ${CATCH2_INCLUDE_DIRS})

add_library(sfml-test-main STATIC
    TestUtilities/SystemUtil.hpp
    TestUtilities/SystemUtil.cpp
    TestUtilities/WindowUtil.hpp
    TestUtilities/WindowUtil.cpp
    TestUtilities/GraphicsUtil.hpp
    TestUtilities/GraphicsUtil.cpp
    TestUtilities/AudioUtil.hpp
    TestUtilities/AudioUtil.cpp
)
target_include_directories(sfml-test-main PUBLIC TestUtilities)
target_link_libraries(sfml-test-main PUBLIC SFML::System Catch2::Catch2WithMain)
set_target_warnings(sfml-test-main)

# set the target flags to use the appropriate C++ standard library
sfml_set_stdlib(Catch2)
sfml_set_stdlib(Catch2WithMain)
sfml_set_stdlib(sfml-test-main)

sfml_set_option(SFML_RUN_DISPLAY_TESTS ON BOOL "ON to run tests that require a display, OFF to ignore it")
if(SFML_RUN_DISPLAY_TESTS)
    target_compile_definitions(sfml-test-main PRIVATE SFML_RUN_DISPLAY_TESTS)
endif()

sfml_set_option(SFML_RUN_AUDIO_DEVICE_TESTS ON BOOL "ON to run tests that require an audio device, OFF to ignore it")
if(SFML_RUN_AUDIO_DEVICE_TESTS)
    target_compile_definitions(sfml-test-main PRIVATE SFML_RUN_AUDIO_DEVICE_TESTS)
endif()

set(SYSTEM_SRC
    System/Angle.test.cpp
    System/Clock.test.cpp
    System/Config.test.cpp
    System/Err.test.cpp
    System/Exception.test.cpp
    System/FileInputStream.test.cpp
    System/MemoryInputStream.test.cpp
    System/Sleep.test.cpp
    System/String.test.cpp
    System/Time.test.cpp
    System/Utf.test.cpp
    System/Vector2.test.cpp
    System/Vector3.test.cpp
)
sfml_add_test(test-sfml-system "${SYSTEM_SRC}" "")
target_compile_definitions(test-sfml-system PRIVATE
    EXPECTED_SFML_VERSION_MAJOR=${SFML_VERSION_MAJOR}
    EXPECTED_SFML_VERSION_MINOR=${SFML_VERSION_MINOR}
    EXPECTED_SFML_VERSION_PATCH=${SFML_VERSION_PATCH}
    EXPECTED_SFML_VERSION_IS_RELEASE=$<IF:$<BOOL:${VERSION_IS_RELEASE}>,true,false>
)

set(WINDOW_SRC
    Window/Clipboard.test.cpp
    Window/Context.test.cpp
    Window/ContextSettings.test.cpp
    Window/Cursor.test.cpp
    Window/Event.test.cpp
    Window/GlResource.test.cpp
    Window/Joystick.test.cpp
    Window/Keyboard.test.cpp
    Window/VideoMode.test.cpp
    Window/Vulkan.test.cpp
    Window/Window.test.cpp
    Window/WindowBase.test.cpp
)
sfml_add_test(test-sfml-window "${WINDOW_SRC}" SFML::Window)

set(GRAPHICS_SRC
    Graphics/BlendMode.test.cpp
    Graphics/CircleShape.test.cpp
    Graphics/Color.test.cpp
    Graphics/ConvexShape.test.cpp
    Graphics/CoordinateType.test.cpp
    Graphics/Drawable.test.cpp
    Graphics/Font.test.cpp
    Graphics/Glsl.test.cpp
    Graphics/Glyph.test.cpp
    Graphics/Image.test.cpp
    Graphics/Rect.test.cpp
    Graphics/RectangleShape.test.cpp
    Graphics/Render.test.cpp
    Graphics/RenderStates.test.cpp
    Graphics/RenderTarget.test.cpp
    Graphics/RenderTexture.test.cpp
    Graphics/RenderWindow.test.cpp
    Graphics/Shader.test.cpp
    Graphics/Shape.test.cpp
    Graphics/Sprite.test.cpp
    Graphics/StencilMode.test.cpp
    Graphics/Text.test.cpp
    Graphics/Texture.test.cpp
    Graphics/Transform.test.cpp
    Graphics/Transformable.test.cpp
    Graphics/Vertex.test.cpp
    Graphics/VertexArray.test.cpp
    Graphics/VertexBuffer.test.cpp
    Graphics/View.test.cpp
)
if(SFML_OS_WINDOWS)
    list(APPEND GRAPHICS_SRC
        Graphics/WindowHandleWin32.test.cpp
    )
endif()
sfml_add_test(test-sfml-graphics "${GRAPHICS_SRC}" SFML::Graphics)
if(SFML_RUN_DISPLAY_TESTS)
    target_compile_definitions(test-sfml-graphics PRIVATE SFML_RUN_DISPLAY_TESTS)
endif()

set(NETWORK_SRC
    Network/Ftp.test.cpp
    Network/Http.test.cpp
    Network/IpAddress.test.cpp
    Network/Packet.test.cpp
    Network/Socket.test.cpp
    Network/SocketSelector.test.cpp
    Network/TcpListener.test.cpp
    Network/TcpSocket.test.cpp
    Network/UdpSocket.test.cpp
)
sfml_add_test(test-sfml-network "${NETWORK_SRC}" SFML::Network)

set(AUDIO_SRC
    Audio/AudioResource.test.cpp
    Audio/InputSoundFile.test.cpp
    Audio/Listener.test.cpp
    Audio/Music.test.cpp
    Audio/OutputSoundFile.test.cpp
    Audio/Sound.test.cpp
    Audio/SoundBuffer.test.cpp
    Audio/SoundBufferRecorder.test.cpp
    Audio/SoundFileFactory.test.cpp
    Audio/SoundFileReader.test.cpp
    Audio/SoundFileWriter.test.cpp
    Audio/SoundRecorder.test.cpp
    Audio/SoundSource.test.cpp
    Audio/SoundStream.test.cpp
)
sfml_add_test(test-sfml-audio "${AUDIO_SRC}" SFML::Audio)

if(SFML_OS_ANDROID AND DEFINED ENV{LIBCXX_SHARED_SO})
    # Because we can only write to the tmp directory on the Android virtual device we will need to build our directory tree under it
    set(TARGET_DIR "/data/local/tmp/$<TARGET_FILE_DIR:test-sfml-system>")

    # Generate script that copies necessary files over to the Android virtual device
    file(GENERATE OUTPUT "${PROJECT_BINARY_DIR}/prepare-android-files.sh" CONTENT
        "#!/bin/bash\n\
        adb shell \"mkdir -p ${TARGET_DIR}\"\n\
        adb push $<TARGET_FILE:test-sfml-audio>    ${TARGET_DIR}\n\
        adb push $<TARGET_FILE:test-sfml-graphics> ${TARGET_DIR}\n\
        adb push $<TARGET_FILE:test-sfml-network>  ${TARGET_DIR}\n\
        adb push $<TARGET_FILE:test-sfml-system>   ${TARGET_DIR}\n\
        adb push $<TARGET_FILE:test-sfml-window>   ${TARGET_DIR}\n\
        adb push $<TARGET_FILE:SFML::Audio>        ${TARGET_DIR}\n\
        adb push $<TARGET_FILE:SFML::Graphics>     ${TARGET_DIR}\n\
        adb push $<TARGET_FILE:SFML::Network>      ${TARGET_DIR}\n\
        adb push $<TARGET_FILE:SFML::System>       ${TARGET_DIR}\n\
        adb push $<TARGET_FILE:SFML::Window>       ${TARGET_DIR}\n\
        adb push $<TARGET_FILE:Catch2>             ${TARGET_DIR}\n\
        adb push $<TARGET_FILE:Catch2WithMain>     ${TARGET_DIR}\n\
        adb push $ENV{LIBCXX_SHARED_SO}            ${TARGET_DIR}\n\
        adb push ${CMAKE_CURRENT_LIST_DIR}         ${TARGET_DIR}\n\
        adb shell \"chmod -R 775 ${TARGET_DIR} && ls -la ${TARGET_DIR}\"\n"
        FILE_PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE)

    # Add the target to invoke the file copy script
    add_custom_target(prepare-android-files COMMAND "${PROJECT_BINARY_DIR}/prepare-android-files.sh")

    # Generate proxy script that translates CTest commands into adb shell commands
    file(GENERATE OUTPUT "${PROJECT_BINARY_DIR}/run-in-adb-shell.sh" CONTENT
        "#!/bin/bash\n\
        adb shell \"cd ${TARGET_DIR}/test; LD_LIBRARY_PATH=${TARGET_DIR} /data/local/tmp/$1 \\\"$2\\\" \\\"$3\\\" \\\"$4\\\" \\\"$5\\\" \\\"$6\\\" \\\"$7\\\" \\\"$8\\\" \\\"$9\\\"\"\n"
        FILE_PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE)
endif()

if(SFML_ENABLE_COVERAGE AND SFML_OS_WINDOWS AND NOT SFML_COMPILER_GCC)
    # Try to find and use OpenCppCoverage for coverage reporting when building with MSVC
    find_program(OpenCppCoverage_BINARY "OpenCppCoverage.exe")

    if(OpenCppCoverage_BINARY)
        execute_process(COMMAND "${OpenCppCoverage_BINARY}" --help ERROR_VARIABLE OpenCppCoverage_HELP_OUTPUT OUTPUT_QUIET)

        if(OpenCppCoverage_HELP_OUTPUT MATCHES "OpenCppCoverage Version: ([.0-9]+)")
            set(OpenCppCoverage_VERSION "${CMAKE_MATCH_1}")
        endif()
    endif()

    include(FindPackageHandleStandardArgs)

    find_package_handle_standard_args(OpenCppCoverage
        REQUIRED_VARS OpenCppCoverage_BINARY
        VERSION_VAR OpenCppCoverage_VERSION
    )
endif()

if(SFML_ENABLE_COVERAGE AND OpenCppCoverage_FOUND)
    # Use OpenCppCoverage
    message(STATUS "Using OpenCppCoverage to generate coverage report")

    string(REPLACE "/" "\\" COVERAGE_EXCLUDE "${CMAKE_CTEST_COMMAND}")
    string(REPLACE "/" "\\" COVERAGE_SRC "${PROJECT_SOURCE_DIR}/src")
    string(REPLACE "/" "\\" COVERAGE_INCLUDE "${PROJECT_SOURCE_DIR}/include")

    # We need to patch the OpenCppCoverage output to remove path prefixes so Coveralls doesn't get confused
    cmake_path(GET PROJECT_SOURCE_DIR ROOT_NAME COVERAGE_ROOT_NAME)
    string(REPLACE "/" "\\\\" COVERAGE_PATH_PREFIX "${PROJECT_SOURCE_DIR}/")
    string(REPLACE "${COVERAGE_ROOT_NAME}\\\\" "" COVERAGE_PATH_PREFIX "${COVERAGE_PATH_PREFIX}")

    file(WRITE "${PROJECT_BINARY_DIR}/patch_coverage.cmake"
         "file(READ \"${PROJECT_BINARY_DIR}/coverage.out\" COVERAGE_OUT)\n\
         string(REPLACE \"${COVERAGE_PATH_PREFIX}\" \"\" COVERAGE_OUT \"\${COVERAGE_OUT}\")\n\
         string(REPLACE \"${COVERAGE_ROOT_NAME}\" \".\" COVERAGE_OUT \"\${COVERAGE_OUT}\")\n\
         file(WRITE \"${PROJECT_BINARY_DIR}/coverage.out\" \"\${COVERAGE_OUT}\")\n")

    set(COVERAGE_PREFIX ${OpenCppCoverage_BINARY} --quiet --export_type cobertura:${PROJECT_BINARY_DIR}/coverage.out --cover_children --excluded_modules "${COVERAGE_EXCLUDE}" --sources "${COVERAGE_SRC}" --sources "${COVERAGE_INCLUDE}" --)
else()
    # On all other systems, we just run an empty script
    file(WRITE "${PROJECT_BINARY_DIR}/patch_coverage.cmake" "")
endif()

# Convenience for building and running tests in a single command
add_custom_target(runtests DEPENDS test-sfml-system test-sfml-window test-sfml-graphics test-sfml-network test-sfml-audio)
add_custom_command(TARGET runtests
                   COMMENT "Run tests"
                   POST_BUILD
                   COMMAND ${COVERAGE_PREFIX} ${CMAKE_CTEST_COMMAND} --output-on-failure -C $<CONFIG>
                   COMMAND ${CMAKE_COMMAND} -P "${PROJECT_BINARY_DIR}/patch_coverage.cmake"
                   VERBATIM)

=== examples/X11/CMakeLists.txt ===
find_package(X11 REQUIRED)

# all source files
set(SRC X11.cpp)

# define the X11 target
sfml_add_example(X11Example GUI_APP
                 SOURCES ${SRC}
                 DEPENDS SFML::Window X11::X11)

# external dependency headers
target_include_directories(X11Example SYSTEM PRIVATE ${PROJECT_SOURCE_DIR}/examples/include)

=== examples/cocoa/CMakeLists.txt ===
enable_language(OBJC OBJCXX)

# Usage: compile_xib(INPUT path/to/file.xib OUTPUT path/to/file.nib)
function(compile_xib)
    cmake_parse_arguments(THIS "" "INPUT;OUTPUT" "" ${ARGN})
    if(NOT THIS_INPUT)
        message(FATAL_ERROR "Missing required argument INPUT in call to compile_xib()")
    endif()

    if(NOT THIS_OUTPUT)
        message(FATAL_ERROR "Missing required argument OUTPUT in call to compile_xib()")
    endif()

    if(NOT DEFINED IBTOOL)
        find_program(IBTOOL ibtool HINTS "/usr/bin" "${OSX_DEVELOPER_ROOT}/usr/bin")
    endif()
    if(NOT IBTOOL)
        message(FATAL_ERROR "ibtool is required to compile .xib files but wasn't found.")
    endif()

    # Default args taken from Xcode 9 when it generates a nib from a xib
    set(DEFAULT_ARGS --errors --warnings --notices --module cocoa --auto-activate-custom-fonts --target-device mac --output-format human-readable-text)

    add_custom_command(OUTPUT "${THIS_OUTPUT}"
        COMMAND "${IBTOOL}" ${DEFAULT_ARGS} "${THIS_INPUT}" --compile "${THIS_OUTPUT}"
        DEPENDS "${THIS_INPUT}"
        COMMENT "Generating ${THIS_OUTPUT}"
        VERBATIM)
endfunction()

# all source files
set(SRC CocoaAppDelegate.h
        CocoaAppDelegate.mm
        NSString+stdstring.h
        NSString+stdstring.mm
        main.m)

compile_xib(INPUT "${CMAKE_CURRENT_SOURCE_DIR}/MainMenu.xib" OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/MainMenu.nib")

# all resource files
set(RESOURCES resources/icon.icns
              resources/tuffy.ttf
              resources/logo.png
              resources/blue.png
              resources/green.png
              resources/red.png
              resources/Credits.rtf
              ${CMAKE_CURRENT_BINARY_DIR}/MainMenu.nib)
set_source_files_properties(${RESOURCES} PROPERTIES
                            MACOSX_PACKAGE_LOCATION Resources)

# define the cocoa target and customize it
sfml_add_example(cocoa
                 SOURCES ${SRC}
                 BUNDLE_RESOURCES ${RESOURCES}
                 DEPENDS SFML::Graphics)
set_target_properties(cocoa PROPERTIES
                      MACOSX_BUNDLE ON
                      MACOSX_BUNDLE_INFO_PLIST ${CMAKE_CURRENT_SOURCE_DIR}/resources/Cocoa-Info.plist)
target_link_libraries(cocoa PRIVATE "-framework Cocoa" "-framework Foundation")

=== examples/event_handling/CMakeLists.txt ===
# all source files
set(SRC EventHandling.cpp)

# define the event_handling target
sfml_add_example(event_handling GUI_APP
                 SOURCES ${SRC}
                 DEPENDS SFML::Graphics)

=== examples/island/CMakeLists.txt ===
find_package(Threads REQUIRED)

# all source files
set(SRC Island.cpp)

# define the island target
sfml_add_example(island GUI_APP
                 SOURCES ${SRC}
                 DEPENDS SFML::Graphics
                 RESOURCES_DIR resources)

# external dependency headers
target_include_directories(island SYSTEM PRIVATE ${PROJECT_SOURCE_DIR}/examples/island)

target_link_libraries(island PRIVATE Threads::Threads)

=== examples/joystick/CMakeLists.txt ===
# all source files
set(SRC Joystick.cpp)

# define the joystick target
sfml_add_example(joystick GUI_APP
                 SOURCES ${SRC}
                 DEPENDS SFML::Graphics
                 RESOURCES_DIR resources)

=== examples/opengl/CMakeLists.txt ===
# all source files
set(SRC OpenGL.cpp)

if(SFML_OS_IOS)
    set(RESOURCES
        resources/background.jpg
        resources/tuffy.ttf)
    set_source_files_properties(${RESOURCES} PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
endif()

# define the opengl target
sfml_add_example(opengl GUI_APP
                 SOURCES ${SRC}
                 BUNDLE_RESOURCES ${RESOURCES}
                 DEPENDS SFML::Graphics
                 RESOURCES_DIR resources)

# external dependency headers
target_include_directories(opengl SYSTEM PRIVATE ${PROJECT_SOURCE_DIR}/examples/include)

=== examples/raw_input/CMakeLists.txt ===
# all source files
set(SRC RawInput.cpp)

# define the raw_input target
sfml_add_example(raw_input GUI_APP
                 SOURCES ${SRC}
                 DEPENDS SFML::Graphics)

=== examples/shader/CMakeLists.txt ===
# all source files
set(SRC Shader.cpp)

# define the shader target
sfml_add_example(shader GUI_APP
                 SOURCES ${SRC}
                 DEPENDS SFML::Graphics
                 RESOURCES_DIR resources)

=== debian/changelog ===
libsfml (3.0.2+dfsg-1) unstable; urgency=medium

  * New upstream version.

  * d/control: Bump standards version.
  * d/copyright: Update date.
  * d/patches: Refresh and drop patches applied upstream.

 -- James Cowgill <jcowgill@debian.org>  Fri, 19 Sep 2025 21:16:23 +0100

=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		-DBUILD_SHARED_LIBS=ON \
		-DSFML_BUILD_DOC=$(if $(findstring libsfml-doc,$(shell dh_listpackages)),ON,OFF) \
		-DSFML_BUILD_EXAMPLES=ON \
		-DSFML_BUILD_TEST_SUITE=ON \
		-DSFML_RUN_AUDIO_DEVICE_TESTS=OFF \
		-DSFML_RUN_DISPLAY_TESTS=OFF

execute_after_dh_auto_build-indep:
	dh_auto_build -- doc

override_dh_auto_test-indep:

override_dh_installexamples:
	dh_installexamples -X.gitignore -Xandroid

override_dh_compress:
	dh_compress -XSFML.tag

=== debian/tests/control ===
--- 
+++ 
@@ -6,6 +6,10 @@
 Depends: cmake, g++, libsfml-dev, make
 Restrictions: superficial
 
+Tests: smoke-cmake-min
+Depends: cmake, g++, libsfml-dev, make
+Restrictions: superficial
+
 Tests: upstream-tests
 Depends: cmake, g++, libcatch2-dev, libsfml-dev, make, xserver-xorg-core, xserver-xorg-video-dummy
 Restrictions: allow-stderr breaks-testbed

=== debian/watch ===
# See uscan(1) for format
version=4

# From GitHub
opts=uversionmangle=s/-rc\./~rc/,dversionmangle=auto,repacksuffix=+dfsg \
  https://github.com/SFML/SFML/tags .*/v?(\d\S*)\.tar\.gz
